Description

概要

Time の小数（ナノ秒）を指定した桁で切り捨てるメソッドの提案になります。

現状

小数を丸める Time#round はあるが小数を切り捨てるメソッドがない

精度が異なる時間を比較したり保存したい場合に小数を切り捨てたいケースがある

例えば、小数の精度が3桁で扱われている DB からデータを取得したい場合など

Ruby 以外で時間に依存する場合に切り捨てや丸めに柔軟に対応したい

提案

指定した桁の小数を切り捨てる Time#floor メソッドの追加

Time#floor の挙動

Time#round と同じような使い方になります。

require 'time'

t = Time.utc(2010,3,30, 5,43,"25.123456789".to_r)

t.iso8601(10)           #=> "2010-03-30T05:43:25.1234567890Z"

# 引数に精度（桁数）を渡す

t.floor(0).iso8601(10)  #=> "2010-03-30T05:43:25.0000000000Z"

t.floor(1).iso8601(10)  #=> "2010-03-30T05:43:25.1000000000Z"

t.floor(2).iso8601(10)  #=> "2010-03-30T05:43:25.1200000000Z"

t.floor(3).iso8601(10)  #=> "2010-03-30T05:43:25.1230000000Z"

t.floor(4).iso8601(10)  #=> "2010-03-30T05:43:25.1234000000Z"

t.floor(5).iso8601(10)  #=> "2010-03-30T05:43:25.1234500000Z"

t.floor(6).iso8601(10)  #=> "2010-03-30T05:43:25.1234560000Z"

t.floor(7).iso8601(10)  #=> "2010-03-30T05:43:25.1234567000Z"

t.floor(8).iso8601(10)  #=> "2010-03-30T05:43:25.1234567800Z"

t.floor(9).iso8601(10)  #=> "2010-03-30T05:43:25.1234567890Z"

t.floor(10).iso8601(10) #=> "2010-03-30T05:43:25.1234567890Z"

# デフォルト引数は 0

t.floor.iso8601(10)     #=> "2010-03-30T05:43:25.0000000000Z"

t = Time.utc(1999,12,31, 23,59,59)

(t + 0.4).floor.iso8601(3)    #=> "1999-12-31T23:59:59.000Z"

(t + 0.49).floor.iso8601(3)   #=> "1999-12-31T23:59:59.000Z"

(t + 0.5).floor.iso8601(3)    #=> "1999-12-31T23:59:59.000Z"

(t + 1.4).floor.iso8601(3)    #=> "2000-01-01T00:00:00.000Z"

(t + 1.49).floor.iso8601(3)   #=> "2000-01-01T00:00:00.000Z"

(t + 1.5).floor.iso8601(3)    #=> "2000-01-01T00:00:00.000Z"

t = Time.utc(1999,12,31, 23,59,59)

(t + 0.123456789).floor(4).iso8601(6)  #=> "1999-12-31T23:59:59.123400Z"
問題点

次のケースで意図しない値が返って来ます。

t = Time.utc(1999,12,31, 23,59,59)

# + 0.6 すると 1999-12-31T23:59:59.6000000000Z になる

# なので floor(1) を行うと 1999-12-31T23:59:59.6000000000Z になってほしいが .5 になって返ってくる

pp (t + 0.6).floor(1).iso8601(10)

# => "1999-12-31T23:59:59.5000000000Z"

# これは + 0.6 した際に桁落ちしているのが影響している

pp (t + 0.6).iso8601(10)

# => "1999-12-31T23:59:59.5999999999Z"

 また、 Time#round でも似たような挙動となっています。

t = Time.utc(1999,12,31, 23,59,59)

# + 0.5 では意図する結果になる

pp (t + 0.5).round.iso8601(10)

# => "2000-01-01T00:00:00.0000000000Z"

# + 0.6 - 0.1 で計算すると意図しない結果になる

pp (t + 0.6 - 0.1).round.iso8601(10)

# => "1999-12-31T23:59:59.0000000000Z"

# これもナノ秒が以下のような値になっている為

pp (t + 0.5).iso8601(10)

# => "1999-12-31T23:59:59.5000000000Z"

pp (t + 0.6 - 0.1).iso8601(10)

# => "1999-12-31T23:59:59.4999999999Z"

 現状ではこれが仕様かバグか判断出来なかったのでそのまま（上記の挙動）になっています。

pull request : https://github.com/ruby/ruby/pull/2092
History

#1 - 03/11/2019 04:10 AM - akr (Akira Tanaka)

良い機能だと思います。

#2 - 03/11/2019 06:25 AM - mrkn (Kenta Murata)

ActiveRecord を使うアプリケーションで、時刻をDBに入れて取り出すと秒の単位で切り捨てられます。

昔 Rails アプリケーションを作っていた頃は、この挙動のためにテストコードでの時刻の比較が面倒だったことを思い出しました。

#3 - 03/11/2019 06:27 AM - knu (Akinori MUSHA)

テストコードで Time.at(time.to_i) とかやることは多いですね。

#4 - 03/11/2019 06:31 AM - matz (Yukihiro Matsumoto)

Accepted.

Matz.

#5 - 03/11/2019 06:36 AM - osyo (manga osyo)

レビューありがとうございます！

#6 - 03/11/2019 02:13 PM - zverok (Victor Shepelev)

Shouldn't there be also ceil for completeness, if we already have round and floor?

#7 - 03/11/2019 02:27 PM - akr (Akira Tanaka)

zverok (Victor Shepelev) wrote:

Shouldn't there be also ceil for completeness, if we already have round and floor?

 No one created a issue for that, yet.

I'm positive, though.

#8 - 04/20/2019 05:00 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

Applied in changeset trunk|r67632.
